(function (win) {
    win.scrollGlide = {
        s: null,
        p: null,
        t: null,
        timer: null,

        intprase: function (v) {
            v = parseInt(v);
            return isNaN(v) ? 0 : v;
        },

        getInfo: function (e) {
            var l = 0;
            var t = 0;
            var w = this.intprase(e.style.width);
            var h = this.intprase(e.style.height);
            var wb = e.offsetWidth;
            var hb = e.offsetHeight;
            while (e.offsetParent) {
                l += e.offsetLeft
						+ (e.currentStyle ? this
								.intprase(e.currentStyle.borderLeftWidth) : 0);
                t += e.offsetTop
						+ (e.currentStyle ? this
								.intprase(e.currentStyle.borderTopWidth) : 0);
                e = e.offsetParent;
            }
            l += e.offsetLeft
					+ (e.currentStyle ? this
							.intprase(e.currentStyle.borderLeftWidth) : 0);
            t += e.offsetTop
					+ (e.currentStyle ? this
							.intprase(e.currentStyle.borderTopWidth) : 0);
            return {
                x: l,
                y: t,
                w: w,
                h: h,
                wb: wb,
                hb: hb
            }
        },

        getRelativeInfo: function (e) {
            if (document.documentElement.getBoundingClientRect) {
                var l = e.getBoundingClientRect().left + document.documentElement.scrollLeft;// 不包含scroll被卷去的部分
                var t = e.getBoundingClientRect().top + document.documentElement.scrollTop;// 不包含scroll被卷去的部分
                return {
                    x: l,
                    y: t
                }
            }
        },

        getScroll: function () {
            var t, l, w, h;
            if (document.documentElement && document.documentElement.scrollTop) {
                t = document.documentElement.scrollTop;
                l = document.documentElement.scrollLeft;
                w = document.documentElement.scrollWidth;
                h = document.documentElement.scrollHeight;
            } else if (document.body) {
                t = document.body.scrollTop;
                l = document.body.scrollLeft;
                w = document.body.scrollWidth;
                h = document.body.scrollHeight;
            }
            return {
                t: t,
                l: l,
                w: w,
                h: h
            }
        },

        clear: function () {
            if (this.timer)
                window.clearInterval(this.timer);

            this.timer = null;
            this.t = null;
            this.p = null;
        },

        scroll: function (t, l) {
            window.scrollTo(0, t)
        },

        glideToTop: function (duration) {
            this.clear();
            this.s = this.getScroll();
            this.t = (new Date).getTime();
            this.timer = window.setInterval(function () {
                var ct = (new Date).getTime();
                var p = (ct - scrollGlide.t) / duration;
                if (ct >= duration + scrollGlide.t) {
                    scrollGlide.clear();
                    scrollGlide.scroll(0, 0);
                } else {
                    st = ((-Math.cos(p * Math.PI) / 2) + 0.5)
							* (0 - scrollGlide.s.t) + scrollGlide.s.t;
                    sl = ((-Math.cos(p * Math.PI) / 2) + 0.5)
							* (0 - scrollGlide.s.l) + scrollGlide.s.l;
                    scrollGlide.scroll(st, sl);
                }
            }, 13);
        },

        glide: function (el, duration) {
            if (typeof el != 'object')
                el = document.getElementById(el);
            if (!el)
                return;

            this.clear();
            this.p = this.getInfo(el);
            this.s = this.getScroll();
            var ss=document.body.scrollHeight;
            
			// 不满足滚动条件,不翻页
            
			console.log("autoScroll:this.s.t="+this.s.t);
			console.log("autoScroll:document.documentElement.clientHeight="+ document.documentElement.clientHeight);
			console.log("autoScroll:this.p.y="+this.p.y);
			console.log("autoScroll:this.p.hb="+this.p.hb);
			
			
			if ((this.s.t + document.documentElement.clientHeight) - (this.p.y + this.p.hb) > 0 ){        		
                return;
            }
			
            
            var bottom = this.s.h - this.p.y;
            if(bottom < document.documentElement.clientHeight){
            	this.p.y = this.s.h - document.documentElement.clientHeight;
            }         
            
            this.t = (new Date).getTime();         
            this.timer = window.setInterval(function () {
                var ct = (new Date).getTime();
                var p = (ct - scrollGlide.t) / duration;
                if (ct >= duration + scrollGlide.t) {
                    scrollGlide.clear();
                    // window.setTimeout(function(){
                    if (scrollGlide.p)
                        scrollGlide.scroll(scrollGlide.p.y, scrollGlide.p.x)
                    // }, 13);
                } else {
                    st = ((-Math.cos(p * Math.PI) / 2) + 0.5)
							* (scrollGlide.p.y - scrollGlide.s.t)
							+ scrollGlide.s.t;
                    sl = ((-Math.cos(p * Math.PI) / 2) + 0.5)
							* (scrollGlide.p.x - scrollGlide.s.l)
							+ scrollGlide.s.l;
                    scrollGlide.scroll(st, sl);
                }
            }, 13);
        },

        scrollTo: function (el) {
            if (typeof el != 'object')
                el = document.getElementById(el);
            if (!el)
                return;

            var p = this.getInfo(el);
            LogUtil.debug("p.x " + p.x + ",  p.y " + p.y);
            this.scroll(p.y, p.x);
        }

    };

})(window);