﻿/// <reference path="SpeechJS.js" />
/// <reference path="const_define.js" />
/// <reference path="jquery-1.10.1.js" />

// 自定义展现器
function DialogPresenter(option) {
    var _this = this;
    //当前段落索引
    var _currentParagraphIndex = 0;
    /**
    * 根据TTS信息生成Html
    * @Public Method
    */
    _this.__proxy__.buildHTML = function (ttsInfo) {
        return initHTML(ttsInfo);
    };

    /**
    * 段落高亮显示
    * @Public Method
    */
    _this.__proxy__.highlight = function (position) {

    }

    /**
    * 清除页面状态
    */
    this.__proxy__.clearHighlight = function () {

    };


    /**
     * 朗读跟踪
     */
    this.__proxy__.handleTrackInfo = function (trackInfo) {

    };

    this.__class__.check.call(this);
       

    /**
    * 根据TTS信息生成Html
    */
    function initHTML(ttsInfo) {
        var paragraphs = ttsInfo.Paragraphs;
        var html = [];
        var globalIndex = 0;
        var  flag = false;
        // 添加段落
        for (var paragraphIndex = 0, pLength = paragraphs.length; paragraphIndex < pLength; paragraphIndex++) {
            var paragraph = paragraphs[paragraphIndex];
            html.push('<div  class="' + SpeechJS.Defines.ParagraphClass + '" pIndex="' + paragraphIndex + '"><ul class="content_normal"><li>');
            var wordsText = '';
            // 添加句子
            for (var senIndex = 0, sLength = paragraph.Sentences.length; senIndex < sLength; senIndex++) {
                var sen = paragraph.Sentences[senIndex];
                html.push('<span class="' + SpeechJS.Defines.SentenceClass + ' txt_english" sIdx="' + senIndex + '">');
                // 添加单词
                var words = sen.Words;
                for (var wIndex = 0, wLength = words.length; wIndex < wLength; wIndex++) {
                    var word = words[wIndex];
                    //拼接文本，用于引擎评测
                    if (word.PY == "" && word.PT.indexOf("</Font>") > -1) {
                        if(word.PT.indexOf(".") > -1 && senIndex==0){
                            flag = true;
                        }
                        if( flag ){
                            if(word.PT.indexOf(".") > -1 ){
                                html.push('<span wIdx="' + wIndex + '" class="'+cssConst.name_span1 + '" >' + word.PT.replace("</Font>", "") + ' </span>');
                            }else{
                                html.push('<span wIdx="' + wIndex + '" class="'+cssConst.name_span2 + '" >' + word.PT.replace("</Font>", "") + ' </span>');
                            }
                        }else{
                            html.push('<span wIdx="' + wIndex + '" class="'+cssConst.name_span1 + '" >' + word.PT.replace("</Font>", "") + ' </span>');
                        }
                        wordsText  += pushWord(word);
                    } else if (word.PY == "") {
                        html.push('<span class="' + cssConst.symbol_span + '" wIdx="' + wIndex + '">' + word.PT + ' </span>');
                        wordsText  += pushWord(word);
                    }else {
                        html.push('<span class="' + SpeechJS.Defines.WordClass + '" wIdx="' + wIndex + '">' + word.PT + ' </span>');
                        wordsText  += pushWord(word);
                    }
                }
                html.push('</span>');
            }
           // html.push('<div class="txt_china gray">' + getTranslate(paragraphIndex) + '</div></li></ul></div>');
            html.push('<div class="txt_china gray"></div></li></ul></div>');
        }

        return html.join('');
    }

    /**
     * 获取单词
     * @param word
     * @returns {string}
     */
    function pushWord(word){
        var  wordsText='';
        if (word.OT !== '') {
            wordsText = word.OT + ' ';
        }else {
            if(word.PY == "" && word.PT.indexOf("</Font>") > -1)  {
                wordsText = word.PT.replace("</Font>", "") + ' ';
            }else{
                wordsText = word.PT + ' ';
            }
        }
        return wordsText;
    }

}
DialogPresenter.prototype = new SpeechJS.PresenterBase();
DialogPresenter.prototype.constructor = DialogPresenter;