﻿/// <reference path="SpeechJS.js" />
/// <reference path="constDefine.js" />
/// <reference path="jquery-1.10.1.js" />

// 自定义展现器
function ParagraphPresenter(option) {
    var _this = this;
    var _currentSenIndex = 0;

    this.__proxy__.buildHTML = function (ttsInfo) {
        return initHTML(ttsInfo);
    };

    /**   
    * 句子高亮显示
    * @Public Method
    */
    this.__proxy__.highlight = function (position) {

    }

    /**
    * 朗读跟踪
    */
    this.__proxy__.handleTrackInfo = function (trackInfo) {

    };

    /**
    * 清除页面状态
    */
    this.__proxy__.clearHighlight = function () {
        _currentSenIndex = 0;
    }

    this.__class__.check.call(this);

    /**
    * 根据TTS信息生成Html
    */
    function initHTML(ttsInfo) {
        var paragraphs = ttsInfo.Paragraphs;
        var html = [];
        var globalIndex = 0;
        // 添加段落
        for (var paragraphIndex = 0, pLength = paragraphs.length; paragraphIndex < pLength; paragraphIndex++) {

            var paragraph = paragraphs[paragraphIndex];
            html.push('<div class="' + SpeechJS.Defines.ParagraphClass + ' txt_english3" pIndex="' + paragraphIndex + '">');
            // 添加句子
            for (var senIndex = 0, sLength = paragraph.Sentences.length; senIndex < sLength; senIndex++) {
                var sen = paragraph.Sentences[senIndex];
                html.push('<span class="' + SpeechJS.Defines.SentenceClass + '" sIdx="' + senIndex + '">');
                var wordsText = '';
                // 添加单词
                var words = sen.Words;
                for (var wIndex = 0, wLength = words.length; wIndex < wLength; wIndex++) {
                    var word = words[wIndex];
                    html.push('<b class="' + SpeechJS.Defines.WordClass + '" wIdx="' + wIndex + '">' + word.PT + ' </b>');
                    //拼接文本，用于引擎评测
                    if (word.OT !== '') {
                        wordsText += word.OT + ' ';
                    }
                    else {
                        wordsText += word.PT + ' ';
                    }
                }

                html.push('</span>');
                //添加句子图片符号到页面
                var senImg = $('<div class="point" sIdx="' + senIndex + '" style="position: absolute;"><img src="images/point2.png" /></div>').hide();
                $('#lineSymbol').append(senImg);
            }

            html.push('</div>');
        }
        return html.join('');
    }


}
ParagraphPresenter.prototype = new SpeechJS.PresenterBase();
ParagraphPresenter.prototype.constructor = ParagraphPresenter;