﻿/*
* 单句弹出层
*/
function SentencePopup(option) {
    var _this = this;
    var _option = option;
    var _speecher = _option.speecher;
    var _currentTTS = _option.tts;
    var _ttsType = _option.ttsType;
    var _newsType = _option.newsType;
    var _isOpenRecord = _option.isOpenRecord;
    //滑动数据块
    var _slides = [];
    //滑动数据块容器
    var _slidesView = {};
    //弹出层底部关闭栏
    var _closeBar = {};
    //弹出层底部工具栏
    var _footerBar = {};
    //句子或段落总数
    var _length = (function () {
        var length = 0;
        if (_ttsType === 'Sentence') {
            length = _speecher.Presenter.TTS.AllSentences.length;
        }
        else {
            length = _speecher.Presenter.TTS.Paragraphs.length;
        }
        return length;
    })()

    initDom();

    function initDom() {
        createSlidesView();
        createFooterBar();
        createCloseBar();
    }

    function createSlidesView() {
        var width = 480 * _length;
        _slidesView = $('<div class="pop_hd" style="overflow:hidden"><div id="pop_slides" style="width:' + width + 'px"></div></div>');
        var sens = _ttsType === 'Paragraph' ? _speecher.Presenter.TTS.Paragraphs : _speecher.Presenter.TTS.AllSentences;

        var evalResult;
        for (var index = 0; index < _length; index++) {
            evalResult = _speecher.Presenter.getEvalResult(index);
            var html = '<div class="pop_left">';
            if (evalResult) {
                html += createScroeHtml(sens[index], evalResult);
            }
            else {
                html += createNormalHtml(sens[index]);
            }
            html += '</div>';
            _slides.push($(html));
            _slidesView.find("#pop_slides").append(_slides[index]);
        }
    }

    //生成带得分的单句详情html
    function createScroeHtml(tts, result) {
        if (_ttsType === 'Paragraph') {
            var html = '<div class="pop_content">' + createScoreHead(result) + '<div class="pd10"><div class="txt_english">';
            var paragraph = tts;
            html += getWordsHtml(paragraph, result);
            html += '</div><div class="txt_china gray">' + _speecher.Presenter.getTranslate(tts.GlobalIndex) + '</div></div></div>';
            return html;
        }
        else if (_ttsType === 'Sentence') {
            var html = '<div class="pop_content">' + createScoreHead(result) + '<div class="pd10"><div class="txt_english">';
            var sentence = tts;
            for (var wIndex = 0, wLength = sentence.Words.length; wIndex < wLength; wIndex++) {
                var word = sentence.Words[wIndex];
                var wClass = '';
                if(result.Words[wIndex]){
                	wClass = getWordStatus(result.Words[wIndex].DpMsg);
                }
                html += '<span class="word '+ wClass +'">' + word.PT + ' </span>';
            }
            html += '</div></div></div>';
            return html;
        }
    }
    
    //获取单词html，包含得分情况
    function getWordsHtml(paragraph, result){
    	var html= '';
        for (var senIndex = 0, sLength = paragraph.Sentences.length; senIndex < sLength; senIndex++) {
            var sen = paragraph.Sentences[senIndex];
            var words = sen.Words;
            for (var wIndex = 0, wLength = words.length; wIndex < wLength; wIndex++) {
                var wClass = '';
                if (isArray(result) && result[senIndex].Words[wIndex]) {
                	wClass = getWordStatus(result[senIndex].Words[wIndex].DpMsg);
                }
                else if(result.Words && result.Words[wIndex]){
                	wClass = getWordStatus(result.Words[wIndex].DpMsg);           		
                }
                
                var word = words[wIndex];
                html += '<span class="word '+ wClass +'">' + word.PT + ' </span>';
            }
        }  
        return html;
    }

    //生成不带得分的单句详情html
    function createNormalHtml(tts) {
        if (_ttsType === 'Paragraph') {
            var html = '<div class="pop_content"><div class="pd10"><div class="txt_english">';
            var paragraph = tts;
            for (var senIndex = 0, sLength = paragraph.Sentences.length; senIndex < sLength; senIndex++) {
                var sen = paragraph.Sentences[senIndex];
                var words = sen.Words;
                for (var wIndex = 0, wLength = words.length; wIndex < wLength; wIndex++) {
                    var word = words[wIndex];
                    html += '<span class="word">' + word.PT + ' </span>';
                }
            }
            html += '</div><div class="txt_china gray">' + _speecher.Presenter.getTranslate(tts.GlobalIndex) + '</div></div></div>';
            return html;

        }
        else if (_ttsType === 'Sentence') {
            var html = '<div class="pop_content"><div class="pd10"><div class="txt_english">';
            var sentence = tts;
            for (var wIndex = 0, wLength = sentence.Words.length; wIndex < wLength; wIndex++) {
                var word = sentence.Words[wIndex];
                html += '<span class="word">' + word.PT + ' </span>';
            }
            html += '</div></div></div>';
            return html;
        }
    }

    function createScoreHead(result) {
        var totalScore = 0;
        if (isArray(result)) {
            var num = 0;
            for (var rIndex = 0, rLength = result.length; rIndex < rLength; rIndex++) {
                totalScore += result[rIndex].TotalScore;
                num++;
            }
            totalScore = totalScore / num;
        }
        else {
            totalScore = result.TotalScore;
        }
        totalScore = Math.round(totalScore);
        var scoreImg = getScoreImg(totalScore);
        var html = '<div class="pop_top"><div class="face"><img src="' + scoreImg + '" /></div><div class="result">' + totalScore + '</div>' +
		            '<div class="clear"></div></div>';
        return html;
    }

    function createFooterBar() {
        var footBar = new FooterBar(_this);
        _footerBar = footBar;
    }

    function createCloseBar() {
        var html = '<table border="0" cellpadding="0" cellspacing="0" class="table_line"><tr><th><img src="images/bottom_line_left.png" width="10" height="38" /></th>' +
        '<td><a href="javascript: void(0)"><img src="images/drop_down.png" /></td><th><img src="images/bottom_line_right.png" width="10" height="38" /></th></tr></table>';
        var dom = document.createElement('div');
        dom.setAttribute('id', 'pop_close');
        dom.innerHTML = html;
        dom.onclick = function () {
            _this.method.close();
        }
        _closeBar = dom;
    }

    //显示评测结果
    function showScoreReport(result) {
        if (_currentTTS.GlobalIndex <= _slides.length) {
            var currentSlide = _slides[_currentTTS.GlobalIndex];
            var evalResult = _speecher.Presenter.getEvalResult(_currentTTS.GlobalIndex);
            if (evalResult) {
                currentSlide.html(createScroeHtml(_currentTTS, evalResult));
            }
        }
    }
    
    //获取单词的对错状态
    function getWordStatus(code){
    	var status = '';
    	switch(code){
    		//正常
	    	case Const.ESEEConst.ISE_RESULT_NO_ERR:	  
	    		status = '';
	    		break;
        	//漏读
	    	case Const.ESEEConst.ISE_RESULT_MISS:
	    		status = Const.CssConst.word_miss;
	    		break;
        	//增读
	    	case Const.ESEEConst.ISE_RESULT_INSERT:
	    		break;
        	//错读
	    	case Const.ESEEConst.ISE_RESULT_ERR:
	    		status = Const.CssConst.word_error;
	    		break;
    		default:
    			break;
    	}
    	return status;
    }

    //判断是否是数组
    function isArray(v) {
        return toString.apply(v) === '[object Array]';
    }

    //通过得分获取语句的得分状态图片
    function getScoreImg(score) {
        score = 100 * (score / 5);
        if (score < 60)
            return Const.ImgConst.eval_very_bad_img;
        else if (score < 70)
            return Const.ImgConst.eval_bad_img;
        else if (score < 80)
            return Const.ImgConst.eval_good_img;
        else
            return Const.ImgConst.eval_very_good_img;
    }
    
    //获取总成绩
    function getTotalScore(){
    	if(_speecher.Presenter.totalScore < 0){
    		return -1;
    	}
    	
		var score = 0;
    	var result = _speecher.Presenter.getEvalResult(-1);
    	if(result && result.length > 0){
    		var rLength = result.length;
    		for(var rIndex = 0; rIndex < rLength; rIndex ++){
    			score += result[rIndex].TotalScore;
    		}
    		score = Math.round(score/rLength);
        	_speecher.Presenter.totalScore = score;
        	return score;
    	}
    	else{
        	return -1;
    	}
    }

    /**
    * 底部工具栏
    */
    function FooterBar(base) {
        var _base = base;
        var _this = this;
        var _dom;

        //播放按钮
        var _btnPlayer;
        //录音按钮
        var _btnRecorder;
        //回放按钮
        var _btnReplayer;
        //后退按钮
        var _btnPrevious;
        //前进按钮
        var _btnNext;
        //底部工具条状态
        var _footerState = {
            normal: 'normal',
            player: 'player',
            replayer: 'replayer',
            recorder: 'recorder'
        }

        var _cssConst = {
            play_nor: 'c_playnor',
            stop_nor: 'c_stopnor',
            record_nor: 'c_micpre',
            stop_record_nor: 'c_micnor'
        }

        //当前状态
        var _currentState = _footerState.normal;

        /**
        * 播放器代理
        */
        var _playerProxy = _this.playerProxy = {
            /**
            * 播放
            */
            paly: function () {
                _speecher.Player.playRange(Math.round(_currentTTS.ST * 1000), Math.round(_currentTTS.ET * 1000));
                _btnPlayer.attr('class', _cssConst.stop_nor);
            },
            /**
            * 停止
            */
            stop: function () {
                _btnPlayer.attr('class', _cssConst.play_nor);
                _speecher.Player.stop();
            },
            /**
            * 单句播放结束
            */
            onRangePlayEnd: function () {
                if (_currentState !== _footerState.normal) {
                    _currentState = _footerState.normal;
                }
                _btnPlayer.attr('class', _cssConst.play_nor);
            }
        }

        var _recordProxy = _this.recordProxy = {
            /**
            * 开始录音
            */
            startEval: function (type, text) {
                _speecher.Recorder.startEval(type, text);
                restoreBtnRecord(_cssConst.record_nor);
            },
            /**
            * 取消评测
            */
            cancelEval: function () {
                _speecher.Recorder.cancelEval();
                restoreBtnRecord(_cssConst.stop_record_nor);
            },
            /**
            * 提交评测
            */
            stopEval: function () {
                _speecher.Recorder.stopEval();
                //restoreBtnRecord(_cssConst.stop_record_nor);
            },
            /**
            * 评测结果回调
            */
            onEvalResult: function (e) {
                if (_currentState !== _footerState.normal) {
                    _currentState = _footerState.normal;
                }
                restoreBtnRecord(_cssConst.stop_record_nor);
            },
            /**
            * 音量回调
            */
            onSoundEnergy: function (level) {
                if (_currentState === _footerState.normal) {
                    return;
                }
                if (level <= 0) {
                    level = '';
                }
                else if (level > 12) {
                    level = 12;
                }

                _btnRecorder.css("backgroundImage", "url(images/c_mic" + level + ".png)");
            },
            /**
             * 录音完成
             */
            onCompleteLearn:function(e){
                if (_currentState !== _footerState.normal) {
                    _currentState = _footerState.normal;
                }
                restoreBtnRecord(_cssConst.stop_record_nor);
            }
        }

        /**
        * 清除底部工具栏状态
        */
        var _clean = _this.clean = function () {
            switch (_currentState) {
                case _footerState.player:
                    _playerProxy.stop();
                    break;
                case _footerState.recorder:
                    _recordProxy.cancelEval();
                    break;
                case _footerState.replayer:
                    break;
            }
            _currentState = _footerState.normal;
        }

        /**
        * 按钮点击事件
        */
        var _events = {
            /**
            * 播放按钮点击事件
            */
            btnPlayClick: function () {
                if (_currentState === _footerState.player) {
                    _currentState = _footerState.normal;
                    _playerProxy.stop();
                }
                else if (_currentState === _footerState.normal) {
                    _currentState = _footerState.player;
                    _playerProxy.paly();
                }
            },
            /**
            * 录音按钮点击事件
            */
            btnRecordClick: function () {
                if (!_isOpenRecord)
                    return;
                if (_currentState === _footerState.recorder) {
                    //_currentState = _footerState.normal;
                    //返回结果后才还原按钮状态
                    //restoreBtnRecord(_cssConst.stop_record_nor);
                    _recordProxy.stopEval();
                }
                else if (_currentState === _footerState.normal) {
                    _currentState = _footerState.recorder;
                    restoreBtnRecord(_cssConst.record_nor);
                    _recordProxy.startEval(1, _speecher.Presenter.getSynthText(_currentTTS.GlobalIndex));
                }
            },
            /**
            * 回放按钮点击事件
            */
            btnReplayClick: function () {


            },
            /**
            * 上一句
            */
            btnPreviousClick: function () {
                if (_currentTTS.GlobalIndex > 0) {
                    navigateAnimation(false);
                }
            },
            /**
            * 下一句
            */
            btnNextClick: function () {
                if (_currentTTS.GlobalIndex < _length - 1) {
                    navigateAnimation(true);
                }
            }
        }

        initialize();

        function initialize() {
            var html = '<div class="previous_page"><input type="button"  value="" id="btnPrevious" class="previous_pagenor"/></div>' +
             '<div class="bottom_cen"><div class="c_play"><input type="button"  value="" id="btnPlayer" class="c_playnor"/></div><div class="c_mic">' +
            '<input type="button" value="" id="btnRecorder" class="c_micnor"/></div><div class="c_review"><input type="button"  value="" id="btnReplayer" class="c_reviewnor"/>' +
              '</div></div><div class="next_page"><input type="button"  value="" id="btnNext" class="next_pagenor"/></div><div class="clear"></div>';
            _dom = document.createElement('div');
            _dom.setAttribute('class', 'pop_bottom');
            _dom.innerHTML = html;
            _this.dom = _dom;
            initFooterBtn();
        }

        //改变_slidesView的滚动条偏移量，产生滑动效果
        function navigateAnimation(isNext) {
            _clean();
            _currentTTS = getTTS(isNext);
            setNavigateStatus();

            var cLeft = _slidesView.scrollLeft();
            var nLeft = isNext ? cLeft + 480 : cLeft - 480;
            _slidesView.animate({ scrollLeft: nLeft }, 200, function () {
            });
        }

        //初始化下方按钮
        function initFooterBtn() {
            _btnPlayer = $(_dom).find('#btnPlayer');
            _btnRecorder = $(_dom).find('#btnRecorder');
            _btnReplayer = $(_dom).find('#btnReplayer');
            _btnPrevious = $(_dom).find('#btnPrevious');
            _btnNext = $(_dom).find('#btnNext');

            _btnPlayer.click(_events.btnPlayClick);
            _btnRecorder.click(_events.btnRecordClick);
            _btnReplayer.click(_events.btnReplayClick);
            _btnPrevious.click(_events.btnPreviousClick);
            _btnNext.click(_events.btnNextClick);

            setNavigateStatus();
        }

        //还原录音按钮的样式
        function restoreBtnRecord(status) {
            switch (status) {
                case _cssConst.stop_record_nor:
                    _btnRecorder.attr('class', _cssConst.stop_record_nor);
                    _btnRecorder.css("backgroundImage", "url(images/c_mic_nor.png)");
                    break;
                case _cssConst.record_nor:
                    _btnRecorder.attr('class', _cssConst.record_nor);
                    _btnRecorder.css("backgroundImage", "url(images/c_mic.png)");
                    break;
            }
        }

        //设置前进后退按钮的显示/隐藏
        function setNavigateStatus() {
            if (_currentTTS.GlobalIndex === 0) {
                _btnPrevious.hide();
            }
            else {
                _btnPrevious.show();
            }
            if (_currentTTS.GlobalIndex === _length - 1) {
                _btnNext.hide();
            }
            else {
                _btnNext.show();
            }
        }

        //获取其他句子或段落的TTS
        function getTTS(isNext) {
            var tts;
            if (isNext) {
                if (_ttsType === 'Sentence') {
                    tts = _speecher.Presenter.TTS.AllSentences[_currentTTS.GlobalIndex + 1];
                }
                else {
                    tts = _speecher.Presenter.TTS.Paragraphs[_currentTTS.GlobalIndex + 1];
                }
            }
            else {
                if (_ttsType === 'Sentence') {
                    tts = _speecher.Presenter.TTS.AllSentences[_currentTTS.GlobalIndex - 1];
                }
                else {
                    tts = _speecher.Presenter.TTS.Paragraphs[_currentTTS.GlobalIndex - 1];
                }
            }
            return tts;
        }
            
    }

    /**
    *  播放器代理
    */
    _this.playerProxy = {
        /**
        * 单句播放结束
        */
        onRangePlayEnd: function () {
            _footerBar.playerProxy.onRangePlayEnd();
        }
    }

    /**
    * 录音器代理
    */
    _this.recordProxy = {
        /**
        * 评测结果回调
        */
        onEvalResult: function (e) {
            //缓存评测结果
            _speecher.Presenter.cacheEvalResult(_currentTTS.GlobalIndex, e);
            //更新主界面得分情况
            _speecher.Presenter.refreshScoreReport(_currentTTS.GlobalIndex);
            //保存得分到本地
            speecher.Communicate.androidInterface.setLocalScore(getTotalScore(), JSON.stringify(_speecher.Presenter.getEvalResult(-1)));
            _footerBar.recordProxy.onEvalResult(e);
            showScoreReport(e);
        },
        /**
         * 音量回调
         */
        onSoundEnergy: function (e) {
            _footerBar.recordProxy.onSoundEnergy(e);
        },
        /**
         * 完成录音
         */
        onCompleteLearn:function(e){
            _footerBar.recordProxy.onCompleteLearn(e);
        }
    }

    /**
    * 公共方法
    */
    _this.method = {
        /**
        * 生成并显示界面
        */
        show: function () {
            _speecher.Presenter.isDetails = true;
            //如果页面已生成相应dom元素，则先移除
            if (document.getElementById('coverPopup')) {
                $('#coverPopup').remove();
                $('#contentPop').remove();
            }

            var _this = this;

            //透明遮罩层
            var coverObj = document.createElement('div');
            coverObj.id = 'coverPopup';
            coverObj.style.position = 'absolute';
            coverObj.style.zIndex = '1000'
            coverObj.style.left = coverObj.style.top = '0px';
            var clientwidth = Math.max(document.body.clientWidth, document.documentElement.clientWidth);
            var scrollwidth = Math.max(document.body.scrollWidth, document.documentElement.scrollWidth);
            coverObj.style.width = clientwidth >= scrollwidth ? clientwidth + "px" : scrollwidth + "px";
            coverObj.style.height = Math.max(document.body.scrollHeight, document.documentElement.scrollHeight) + 'px';
            coverObj.style.backgroundColor = '#000';
            coverObj.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(opacity=50)';
            coverObj.style.opacity = 0.5;
            coverObj.onclick = function () {
                _this.close();
            }
            //内容部分
            var contentObj = document.createElement('div');
            contentObj.id = 'contentPop';
            contentObj.setAttribute('class', 'wrap');
            contentObj.style.position = 'absolute';
            contentObj.style.zIndex = '1001';
            contentObj.style.top = $(document).scrollTop() + 'px';
            contentObj.style.left = '0px';
            contentObj.appendChild(_slidesView[0]);
            contentObj.appendChild(_footerBar.dom);
            contentObj.appendChild(_closeBar);
            contentObj.style.display = 'none';
            //显示到页面
            $(coverObj).appendTo('body');
            $(contentObj).appendTo('body').slideDown(200);
            //初始化滚动条偏移量
            var sLeft = _currentTTS.GlobalIndex > 0 ? (480 * _currentTTS.GlobalIndex) : 0;
            _slidesView.scrollLeft(sLeft);
        },
        /**
        * 关闭弹出层
        */
        close: function () {
            _footerBar.clean();
            $('#contentPop').slideUp(200, function () {
                $('#coverPopup').hide();
                $('#coverPopup').remove();
                $('#contentPop').remove();
            })
            _speecher.Communicate.androidInterface.setScrollBarEnabled(false);
            _speecher.Presenter.isDetails = false;
        },
        /**
        * 判断是否显示
        */
        isShow: function () {
            if (document.getElementById('coverPopup') && !$("#coverPopup").is(":hidden")) {
                return true;
            }
            return false;
        },
        /**
         * 获取当前索引
         */
        getCurrentIndex: function(){
        	return _currentTTS.GlobalIndex;
        }
    }
}